"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from pydantic import model_serializer
from skylight_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from typing_extensions import NotRequired, TypedDict


class PackageInstallResponseTypedDict(TypedDict):
    status: str
    r"""Status of the operation"""
    message: str
    r"""Human-readable status message"""
    state: str
    r"""State of the instance (running, pending, hibernated, terminated)"""
    command_id: NotRequired[Nullable[str]]
    r"""Command ID for tracking installation progress"""


class PackageInstallResponse(BaseModel):
    status: str
    r"""Status of the operation"""

    message: str
    r"""Human-readable status message"""

    state: str
    r"""State of the instance (running, pending, hibernated, terminated)"""

    command_id: OptionalNullable[str] = UNSET
    r"""Command ID for tracking installation progress"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["command_id"]
        nullable_fields = ["command_id"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
